;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Creating LinearGradient brushes.
;*******************************************************************************************

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  Define.RectI rc1, rc2
  ;Let us create a LinearGradient brush whose starting line runs from (0, 0) to (50, 0) and end line runs from (0, 50) to (50, 50).  
  gdiPlus_RectI(rc1, 0, 0, 50, 50)
  brush.gdiPlus_LinearGradientBrush = gdiPlus_CreateLinearGradientBrushFromRectI(rc1, #ARGB_Blue, #ARGB_Red) ;The two missing optional parameters are the
  If brush
    brush\GetRectI(rc2)
    Debug "Brush type = " + Str(brush\GetType())
    Debug "Brush start line runs from (" + Str(rc2\x) + ", " + Str(rc2\y) + ") to (" + Str(rc2\x + rc2\width) + ", " + Str(rc2\y) + ")"
    ;Set some custom blending (http://msdn.microsoft.com/en-us/library/ms535328(v=VS.85).aspx).
    ;We can retrieve these arrays later with the \GetBlend() method.
      Dim blends.f(3)
        blends(0) = 0 : blends(1) = 0.4 : blends(2) = 0.6 : blends(3) = 1
      Dim positions.f(3)
        positions(0) = 0 : positions(1) = 0.2 : positions(2) = 0.8 : positions(3) = 1
      brush\SetBlend(@blends(), @positions(), 4)
    ;Set some custom interpolation colors. We'll use the same positions array as above (http://msdn.microsoft.com/en-us/library/ms535332(v=VS.85).aspx).
    ;We can retrieve these colors later with the \GetInterpolationColors() method.
      Dim colors.f(3)
        colors(0) = #ARGB_Red : colors(1) = #ARGB_Blue : colors(2) = #ARGB_Green : colors(3) = #ARGB_White
      brush\SetInterpolationColors(@colors(), @positions(), 4)
    Debug "There are " + Str(brush\GetInterpolationColorCount()) + " colors set to be interpolated for this brush."
    brush\Destroy()  
  EndIf
  gdiPlus_Free()
EndIf

End  
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 31
; EnableXP
; Executable = ..\nxExplorerBar.exe