;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Font collections.
;*******************************************************************************************

;In this demo we enumerate all the font families (OpenType) installed in the system.


XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Create a font collection object for the installed system fonts (OpenType fonts).
    fontCollection.gdiPlus_FontCollection = gdiPlus_CreateInstalledFontCollection()
  If fontCollection
    numInstalledFonts = fontCollection\GetFamilyCount()
    Debug "There are " + Str(numInstalledFonts) + " font families in the installed fonts collection."
    ;Retrieve the font families.
      If numInstalledFonts
        Debug "Font families found :"
        Debug "---------------------"
        *buffer = AllocateMemory(numInstalledFonts * SizeOf(INTEGER))
        Dim families.gdiPlus_FontFamily(numInstalledFonts - 1)
        numFamiliesFound = fontCollection\GetFamilies(numInstalledFonts, @families())
        If numFamiliesFound
          For i = 0 To numFamiliesFound-1
            Debug "    " + families(i)\GetFamilyName()       
          Next
          ;Destroy the objects pointed to by the font-families array.
            fontCollection\DestroyFamilies(@families())
        EndIf
      EndIf
    fontCollection\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

End  
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 31
; EnableXP
; Executable = ..\nxExplorerBar.exe