;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Creating images.
;*******************************************************************************************

;In this demo we create a 32-bit GDI+ image (a memory bitmap) of a given width, height and pixel-format.
;We then initialise the image's pixel data separately to match those of a png image which we load separately. 

;We start by loading up the png using PB's image commands.
  UsePNGImageDecoder()
  LoadImage(1, "..\image2.png")
  GetObject_(ImageID(1), SizeOf(BITMAP), bmp.BITMAP)


XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Create our empty image. Note how we match the width and height of our pre-loaded png. This is important if we are to copy the pixel bits across.
  image1.gdiPlus_Image = gdiPlus_CreateBitmap(bmp\bmWidth, bmp\bmHeight, #PixelFormat32bppARGB)
  If image1
    ;In order to set the pixel bits we need to first lock the bits of our GDI+ bitmap.
    ;This requires the use of a BitmapData structure. We use the BitmapData 'helper' class to help out.
    ;Note that the png image we have loaded is 'bottom-up' and thus we set a negative stride value and pass the address of the last row of
    ;the pixel data as representing the first row.
      lockedBitmapData.BitmapData
      gdiPlus_BitmapData(lockedBitmapData, bmp\bmWidth, bmp\bmHeight, -4*bmp\bmWidth, #PixelFormat32bppARGB, bmp\bmBits + (bmp\bmHeight - 1) * (4 * bmp\bmWidth))
    ;Lock the bits.
      gdiPlus_RectI(rc.RectI, 0, 0, bmp\bmWidth, bmp\bmHeight)
      image1\LockBits(rc, #ImageLockModeUserInputBuf|#ImageLockModeWrite, #PixelFormat32bppARGB, lockedBitmapData)
    ;Now unlock the bits. This will copy the bits from the temporary buffer to our GDI+ bitmap.
      image1\UnlockBits(lockedBitmapData)
    ;Uncomment the following to save the image so that you can take a look at it etc.
;      image1\Save("createImage1.png", #GDIPLUS_PNG)
    image1\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 34
; FirstLine = 2
; EnableXP
; Executable = ..\nxExplorerBar.exe