;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Creating images.
;*******************************************************************************************

;In this demo we illustrate how to use the gdiPlus_CreateBitmapFromScan0() constructor.
;We create a 24bppRGB GDI+ bitmap based upon the scan-lines of an existing bitmap which we load using PB's image functions.

;We start by loading up the bmp using PB's image commands.
  LoadImage(1, "..\image3.bmp")
  GetObject_(ImageID(1), SizeOf(BITMAP), bmp.BITMAP)

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Create our image. Note how we match the width and height of our pre-loaded bmp. This is important if we are to copy the pixel bits across.
  ;Note also that we use a negative stride value with the gdiPlus_CreateBitmapFromScan0() function because the loaded bitmap is bottom up.
  stride = 4*((3*bmp\bmWidth+3)/4)
  image1.gdiPlus_Image = gdiPlus_CreateBitmapFromScan0(bmp\bmWidth, bmp\bmHeight, -stride, #PixelFormat24bppRGB, bmp\bmBits + (bmp\bmHeight-1)* stride)
  If image1
    ;Uncomment the following to save the image so that you can take a look at it etc.
      image1\Save("createImage3.bmp", #GDIPLUS_BMP)
    image1\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 23
; EnableXP
; Executable = ..\nxExplorerBar.exe