;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Creating images.
;*******************************************************************************************

;In this demo we illustrate how to use the gdiPlus_CreateBitmapFromBitmapInfo() constructor.
;We create a 24bppRGB GDI+ bitmap based upon a DIB section which we load using PB's image functions.
;An alternative is to use gdiPlus_CreateBitmapFromHBITMAP().

;We start by loading up the bmp using PB's image commands.
  LoadImage(1, "..\image3.bmp")
  GetObject_(ImageID(1), SizeOf(BITMAP), bmp.BITMAP)

;Prepare our BITMAPINFO.
;We use a BITMAPINFOHEADER since we do not require a color table.
  With bmi.BITMAPINFOHEADER
    \biSize = SizeOf(BITMAPINFOHEADER)
    \biWidth=bmp\bmWidth
    \biHeight=bmp\bmHeight
    \biPlanes=1
    \biBitCount=24
    \biCompression=#BI_RGB
  EndWith
;Retrieve the DI bits of the bitmap.
  numBytes = 4*((3*bmp\bmWidth + 3)/4) * bmp\bmHeight
  pixels=AllocateMemory(numBytes)
  If pixels = 0
    MessageRequester("Error!", "Out of memory.")
    End
  EndIf
  hdc = GetDC_(0)
  GetDIBits_(hdc, ImageID(1), 0, bmp\bmHeight, pixels, bmi, #DIB_RGB_COLORS)
  ReleaseDC_(0, hdc)

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Create our image.
  image1.gdiPlus_Image = gdiPlus_CreateBitmapFromBitmapInfo(bmi, pixels)
  If image1
    ;Uncomment the following to save the image so that you can take a look at it etc.
;      image1\Save("createImage4.bmp", #GDIPLUS_BMP)
    image1\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

FreeMemory(pixels)
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 40
; FirstLine = 12
; EnableXP
; Executable = ..\nxExplorerBar.exe