;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Palettes.
;*******************************************************************************************

;In this demo we convert a loaded image to 8bpp greyscale using a very simplistic approach. GDI+ allows for far more sophisticated
;methods which we will demonstrate later.

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Load an image.
  image.gdiPlus_Image = gdiPlus_LoadImage("..\image6.jpg")
  If image
    width = image\GetWidth()
    height = image\GetHeight()
    ;Create an 8bpp image with the same dimensions.
      imageMono.gdiPlus_Image = gdiPlus_CreateBitmap(width, height, #PixelFormat8bppIndexed)
    If imageMono
      ;Create a suitable palette holding 256 shades of grey.
        *palette.ColorPalette = AllocateMemory(SizeOf(ColorPalette) + SizeOf(ARGB)<<8)
        If *palette
          *palette\Flags = #PaletteFlagsGrayScale
          *palette\Count = 256
          For i = 0 To 255
            *palette\Entries[i] = MakeARGB($ff, i, i, i)
          Next
        EndIf
      ;Set the palette.
        imageMono\SetPalette(*palette)
      ;Since we cannot use \SetPixel() on an indexed image, we have to use \LockBits().
        lockedBitmapData.BitmapData
        gdiPlus_BitmapData(lockedBitmapData, width, height, 0, #PixelFormat8bppIndexed, 0)
        gdiPlus_RectI(rc.RectI, 0, 0, width, height)
        If imageMono\LockBits(rc, #ImageLockModeWrite, #PixelFormat8bppIndexed, lockedBitmapData) = #ok
          For i = 0 To height-1
            ;Get the pointer to the pixel data for the current row.
            ;This data is in 8bpp format. Each row is padded to give a length which is a multiple of 4 bytes and thus we use the
            ;stride field etc.
              *ptr.ASCII = lockedBitmapData\Scan0 + i * lockedBitmapData\Stride
            For j = 0 To width-1
              ;Retrieve the ARGB color of the pixel in the loaded image.
                color = image\GetPixel(j, i)
              ;Determine a suitable index into our grey-scale palette. We simply average out the red, green and blue components.
                *ptr\a = (ARGB_Red(color) + ARGB_Green(color) + ARGB_Blue(color))/3
              *ptr + SizeOf(ASCII)
            Next
          Next
          imageMono\UnlockBits(lockedBitmapData)
        EndIf
      imageMono\Save("palette1.bmp", #GDIPLUS_BMP)    
      imageMono\Destroy()
    EndIf
    image\Destroy()
  EndIf
  gdiPlus_Free()
EndIf


; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 56
; FirstLine = 23
; EnableXP
; Executable = ..\nxExplorerBar.exe