;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Image properties.
;*******************************************************************************************

;In this demo we load up a jpg image, add an Ascii property and then examine it's list of properties (metadata). 
;We display a list of all propety IDs found and, in the case of Ascii properties, display the values.

;Compile in ASCII mode only.

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  image.gdiPlus_Image = gdiPlus_LoadImage("..\image6.jpg")
  If image
    ;Set the image title. The string needs to be in Ascii format so compile this program in Ascii mode.
      title$ = "A test title!"
      gdiPlus_PropertyItem(item.PropertyItem, #PropertyTagImageTitle, Len(title$)+1, #PropertyTagTypeASCII, @title$)
      image\SetPropertyItem(item)
    ;Now we retrieve all properties and display some info on them.
    numProperties = image\GetPropertyCount()
    If numProperties
      *buffer = AllocateMemory(numProperties * SizeOf(LONG))
      If *buffer
        If image\GetPropertyIdList(numProperties, *buffer) = #ok
          *ptr.LONG = *buffer
          For i = 0 To numProperties - 1
            itemSize = image\GetPropertyItemSize(*ptr\l)
            Debug "Property " + Str(i) + " has ID = $" + Hex(*ptr\l) + " with property item size = " + Str(itemSize) + " bytes."
            ;If the property is of type #PropertyTagTypeASCII then we output the value.
              If itemSize
                *propItem.PropertyItem = AllocateMemory(itemSize)
                If *propItem        
                  If image\GetPropertyItem(*ptr\l, itemSize, *propItem) = #ok And *propItem\type = #PropertyTagTypeASCII
                    Debug "    Ascii value = " + PeekS(*propItem\value, -1, #PB_Ascii)
                  EndIf
                  FreeMemory(*propItem)
                EndIf
              EndIf
            *ptr + SizeOf(LONG)
          Next 
        EndIf
        FreeMemory(*buffer)      
      EndIf
    EndIf
    image\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

End  
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 11
; EnableXP
; Executable = ..\nxExplorerBar.exe