;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Saving multi-page .tif images. (It seems that, contrary to what MSDN claims, the GDI+ gif encoder cannot create multi-page gifs.)
;*******************************************************************************************

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Load some images to add to a 3-frame tiff.
  image1.gdiPlus_Image = gdiPlus_LoadImage("..\image1.bmp")
  If image1
    image2.gdiPlus_Image = gdiPlus_LoadImage("..\image3.bmp")
    If image2
      image3.gdiPlus_Image = gdiPlus_LoadImage("..\image4.jpg")
      If image3
        ;We need an encoder parameter of type #GDIPLUS_ENCODERSAVEFLAG in order to save a multi-frame tif file.
        encoderParams.gdiPlus_EncoderParameters = gdiPlus_CreateEncoderParameters()
        If encoderParams
          encoderParams\AddParameter(#GDIPLUS_ENCODERSAVEFLAG, #EncoderParameterValueTypeLong, @parameterValue)
          parameterValue = #EncoderValueMultiFrame
          ;Save the first image to a new tif file.
            image1\Save("save3.tif", #GDIPLUS_TIFF, encoderParams)
          ;Save the second image to the tif file.
            parameterValue = #EncoderValueFrameDimensionPage
            image1\SaveAddImage(image2, encoderParams)
          ;Save the third image to the tif file.
            image1\SaveAddImage(image3, encoderParams)
          ;Close the multiframe file.
            parameterValue = #EncoderValueFlush
            image1\SaveAdd(encoderParams)
          encoderParams\Destroy()
        EndIf
        image3\Destroy()
      EndIf
      image2\Destroy()
    EndIf
    image1\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 27
; FirstLine = 5
; EnableXP
; Executable = ..\nxExplorerBar.exe