;***GDI+ wrapper file***
;nxSoftware.com 2010.

;Demo program.
;Creating Matrices.
;*******************************************************************************************

XIncludeFile "..\..\gdiPlus.pbi"

If gdiPlus_Init() = #ok
  ;Create a matrix representing a 45 degree shear along the x-axis followed by a translation of dx = 20, dy = 30 units.
    matrix.gdiPlus_Matrix = gdiPlus_CreateMatrix(1, 0, 1, 1, 20, 30)
  If matrix
    ;Alter our matrix by applying a *2, *3 scale factor after the original transformation.
    ;Check the difference in the debugged output if we switch #MatrixOrderAppend for #MatrixOrderPrepend which would mean that the stretch
    ;would be applied first.
      matrix\Scale(2, 3, #MatrixOrderAppend)
    ;Take a look at the elements.
      Dim elements.f(5)
      matrix\GetElements(@elements())
      Debug "The scaled matrix has elements : a11=" + StrF(elements(0)) + ", a12=" + StrF(elements(1)) + ", a21=" + StrF(elements(2)) + ", a22=" + StrF(elements(3)) + ", dx=" + StrF(elements(4)) + ", dy=" + StrF(elements(5))
    ;If the matrix is invertible we clone it and invert the clone and then display the elements.
      If matrix\IsInvertible()
        cloneMatrix.gdiPlus_Matrix = matrix\Clone()
        If cloneMatrix
          cloneMatrix\Invert()        
          ;Retrieve and display the elements of the inverted matrix.
            cloneMatrix\GetElements(@elements())
            Debug "The inverted matrix has elements : a11=" + StrF(elements(0)) + ", a12=" + StrF(elements(1)) + ", a21=" + StrF(elements(2)) + ", a22=" + StrF(elements(3)) + ", dx=" + StrF(elements(4)) + ", dy=" + StrF(elements(5))
          cloneMatrix\Destroy()        
        EndIf
      EndIf
    matrix\Destroy()
  EndIf
  gdiPlus_Free()
EndIf

End  
; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 18
; EnableXP
; Executable = ..\nxExplorerBar.exe