﻿;/////////////////////////////////////////////////////////////////////////////////
;***GDI+ wrapper file***
;=======================
;
;Brush class.
;This is an abstract base class from which the other brush classes inherit.
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-INTERFACE.

  ;All methods return a gdiPlus status code (0 for okay) unless otherwise stated.
  Interface gdiPlus_Brush Extends gdiPlus_BaseClass
    Destroy()
    GetType.i()                 ;Returns a BrushType constant, e.g. #BrushTypeSolidColor.
  EndInterface
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-CLASS TEMPLATE.

  Macro _gdiPlus_Brush_Template
    _gdiPlus_GenericObject_Template
  EndMacro
;/////////////////////////////////////////////////////////////////////////////////


;-METHODS.

;/////////////////////////////////////////////////////////////////////////////////
Procedure gdiPlus_BrushClass_Destroy(*this._gdiPlus_Brush_Template)
  GdipDeleteBrush(*this\object)
  FreeMemory(*this)
EndProcedure
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
Procedure.i gdiPlus_BrushClass_GetType(*this._gdiPlus_Brush_Template)
  Protected result
  GdipGetBrushType(*this\object, @result)  
  ProcedureReturn result
EndProcedure
;/////////////////////////////////////////////////////////////////////////////////

; IDE Options = PureBasic 4.51 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 34
; FirstLine = 9
; Folding = -
; Markers = 5
; EnableUnicode
; EnableXP
; Executable = nxReportU.dll