﻿;/////////////////////////////////////////////////////////////////////////////////
;***GDI+ header file***
;======================
;By Stephen Rodriguez.
;With thanks to Flype and SFSxOI for their gdiPlus includes.
;
;This file contains imports from the GdiPlus.lib and related constants etc. for GDI+ 1.0.
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-CONSTANTS.

  ;Status constants. Returned from GDI+ functions.
    Enumeration ;{
      #Ok
      #GenericError
      #InvalidParameter
      #OutOfMemory
      #ObjectBusy
      #InsufficientBuffer
      #NotImplemented
      #Win32Error
      #WrongState
      #Aborted
      #FileNotFound
      #ValueOverflow
      #AccessDenied
      #UnknownImageFormat
      #FontFamilyNotFound
      #FontStyleNotFound
      #NotTrueTypeFont
      #UnsupportedGdiplusVersion
      #GdiplusNotInitialized
      #PropertyNotFound
      #PropertyNotSupported
      #ProfileNotFound
    EndEnumeration ;}

  ;ARGB common system colors.
    Enumeration ;{
      #ARGB_AliceBlue            = $FFF0F8FF
      #ARGB_AntiqueWhite         = $FFFAEBD7
      #ARGB_Aqua                 = $FF00FFFF
      #ARGB_Aquamarine           = $FF7FFFD4
      #ARGB_Azure                = $FFF0FFFF
      #ARGB_Beige                = $FFF5F5DC
      #ARGB_Bisque               = $FFFFE4C4
      #ARGB_Black                = $FF000000
      #ARGB_BlanchedAlmond       = $FFFFEBCD
      #ARGB_Blue                 = $FF0000FF
      #ARGB_BlueViolet           = $FF8A2BE2
      #ARGB_Brown                = $FFA52A2A
      #ARGB_BurlyWood            = $FFDEB887
      #ARGB_CadetBlue            = $FF5F9EA0
      #ARGB_Chartreuse           = $FF7FFF00
      #ARGB_Chocolate            = $FFD2691E
      #ARGB_Coral                = $FFFF7F50
      #ARGB_CornflowerBlue       = $FF6495ED
      #ARGB_Cornsilk             = $FFFFF8DC
      #ARGB_Crimson              = $FFDC143C
      #ARGB_Cyan                 = $FF00FFFF
      #ARGB_DarkBlue             = $FF00008B
      #ARGB_DarkCyan             = $FF008B8B
      #ARGB_DarkGoldenrod        = $FFB8860B
      #ARGB_DarkGray             = $FFA9A9A9
      #ARGB_DarkGreen            = $FF006400
      #ARGB_DarkKhaki            = $FFBDB76B
      #ARGB_DarkMagenta          = $FF8B008B
      #ARGB_DarkOliveGreen       = $FF556B2F
      #ARGB_DarkOrange           = $FFFF8C00
      #ARGB_DarkOrchid           = $FF9932CC
      #ARGB_DarkRed              = $FF8B0000
      #ARGB_DarkSalmon           = $FFE9967A
      #ARGB_DarkSeaGreen         = $FF8FBC8F
      #ARGB_DarkSlateBlue        = $FF483D8B
      #ARGB_DarkSlateGray        = $FF2F4F4F
      #ARGB_DarkTurquoise        = $FF00CED1
      #ARGB_DarkViolet           = $FF9400D3
      #ARGB_DeepPink             = $FFFF1493
      #ARGB_DeepSkyBlue          = $FF00BFFF
      #ARGB_DimGray              = $FF696969
      #ARGB_DodgerBlue           = $FF1E90FF
      #ARGB_Firebrick            = $FFB22222
      #ARGB_FloralWhite          = $FFFFFAF0
      #ARGB_ForestGreen          = $FF228B22
      #ARGB_Fuchsia              = $FFFF00FF
      #ARGB_Gainsboro            = $FFDCDCDC
      #ARGB_GhostWhite           = $FFF8F8FF
      #ARGB_Gold                 = $FFFFD700
      #ARGB_Goldenrod            = $FFDAA520
      #ARGB_Gray                 = $FF808080
      #ARGB_Green                = $FF008000
      #ARGB_GreenYellow          = $FFADFF2F
      #ARGB_Honeydew             = $FFF0FFF0
      #ARGB_HotPink              = $FFFF69B4
      #ARGB_IndianRed            = $FFCD5C5C
      #ARGB_Indigo               = $FF4B0082
      #ARGB_Ivory                = $FFFFFFF0
      #ARGB_Khaki                = $FFF0E68C
      #ARGB_Lavender             = $FFE6E6FA
      #ARGB_LavenderBlush        = $FFFFF0F5
      #ARGB_LawnGreen            = $FF7CFC00
      #ARGB_LemonChiffon         = $FFFFFACD
      #ARGB_LightBlue            = $FFADD8E6
      #ARGB_LightCoral           = $FFF08080
      #ARGB_LightCyan            = $FFE0FFFF
      #ARGB_LightGoldenrodYellow = $FFFAFAD2
      #ARGB_LightGray            = $FFD3D3D3
      #ARGB_LightGreen           = $FF90EE90
      #ARGB_LightPink            = $FFFFB6C1
      #ARGB_LightSalmon          = $FFFFA07A
      #ARGB_LightSeaGreen        = $FF20B2AA
      #ARGB_LightSkyBlue         = $FF87CEFA
      #ARGB_LightSlateGray       = $FF778899
      #ARGB_LightSteelBlue       = $FFB0C4DE
      #ARGB_LightYellow          = $FFFFFFE0
      #ARGB_Lime                 = $FF00FF00
      #ARGB_LimeGreen            = $FF32CD32
      #ARGB_Linen                = $FFFAF0E6
      #ARGB_Magenta              = $FFFF00FF
      #ARGB_Maroon               = $FF800000
      #ARGB_MediumAquamarine     = $FF66CDAA
      #ARGB_MediumBlue           = $FF0000CD
      #ARGB_MediumOrchid         = $FFBA55D3
      #ARGB_MediumPurple         = $FF9370DB
      #ARGB_MediumSeaGreen       = $FF3CB371
      #ARGB_MediumSlateBlue      = $FF7B68EE
      #ARGB_MediumSpringGreen    = $FF00FA9A
      #ARGB_MediumTurquoise      = $FF48D1CC
      #ARGB_MediumVioletRed      = $FFC71585
      #ARGB_MidnightBlue         = $FF191970
      #ARGB_MintCream            = $FFF5FFFA
      #ARGB_MistyRose            = $FFFFE4E1
      #ARGB_Moccasin             = $FFFFE4B5
      #ARGB_NavajoWhite          = $FFFFDEAD
      #ARGB_Navy                 = $FF000080
      #ARGB_OldLace              = $FFFDF5E6
      #ARGB_Olive                = $FF808000
      #ARGB_OliveDrab            = $FF6B8E23
      #ARGB_Orange               = $FFFFA500
      #ARGB_OrangeRed            = $FFFF4500
      #ARGB_Orchid               = $FFDA70D6
      #ARGB_PaleGoldenrod        = $FFEEE8AA
      #ARGB_PaleGreen            = $FF98FB98
      #ARGB_PaleTurquoise        = $FFAFEEEE
      #ARGB_PaleVioletRed        = $FFDB7093
      #ARGB_PapayaWhip           = $FFFFEFD5
      #ARGB_PeachPuff            = $FFFFDAB9
      #ARGB_Peru                 = $FFCD853F
      #ARGB_Pink                 = $FFFFC0CB
      #ARGB_Plum                 = $FFDDA0DD
      #ARGB_PowderBlue           = $FFB0E0E6
      #ARGB_Purple               = $FF800080
      #ARGB_Red                  = $FFFF0000
      #ARGB_RosyBrown            = $FFBC8F8F
      #ARGB_RoyalBlue            = $FF4169E1
      #ARGB_SaddleBrown          = $FF8B4513
      #ARGB_Salmon               = $FFFA8072
      #ARGB_SandyBrown           = $FFF4A460
      #ARGB_SeaGreen             = $FF2E8B57
      #ARGB_SeaShell             = $FFFFF5EE
      #ARGB_Sienna               = $FFA0522D
      #ARGB_Silver               = $FFC0C0C0
      #ARGB_SkyBlue              = $FF87CEEB
      #ARGB_SlateBlue            = $FF6A5ACD
      #ARGB_SlateGray            = $FF708090
      #ARGB_Snow                 = $FFFFFAFA
      #ARGB_SpringGreen          = $FF00FF7F
      #ARGB_SteelBlue            = $FF4682B4
      #ARGB_Tan                  = $FFD2B48C
      #ARGB_Teal                 = $FF008080
      #ARGB_Thistle              = $FFD8BFD8
      #ARGB_Tomato               = $FFFF6347
      #ARGB_TRANSPARENT          = $00FFFFFF
      #ARGB_Turquoise            = $FF40E0D0
      #ARGB_Violet               = $FFEE82EE
      #ARGB_Wheat                = $FFF5DEB3
      #ARGB_White                = $FFFFFFFF
      #ARGB_WhiteSmoke           = $FFF5F5F5
      #ARGB_Yellow               = $FFFFFF00
      #ARGB_YellowGreen          = $FF9ACD32
EndEnumeration ;} 

  ;Encoder parameter value types.
    Enumeration ;{
      #EncoderParameterValueTypeByte    = 1 
      #EncoderParameterValueTypeASCII
      #EncoderParameterValueTypeShort 
      #EncoderParameterValueTypeLong
      #EncoderParameterValueTypeRational
      #EncoderParameterValueTypeLongRange 
      #EncoderParameterValueTypeUndefined 
      #EncoderParameterValueTypeRationalRange 
      #EncoderParameterValueTypePointer
    EndEnumeration ;}

  ;Encoder parameter values.
    Enumeration ;{
      #EncoderValueColorTypeCMYK
      #EncoderValueColorTypeYCCK
      #EncoderValueCompressionLZW
      #EncoderValueCompressionCCITT3
      #EncoderValueCompressionCCITT4
      #EncoderValueCompressionRle
      #EncoderValueCompressionNone
      #EncoderValueScanMethodInterlaced
      #EncoderValueScanMethodNonInterlaced
      #EncoderValueVersionGif87
      #EncoderValueVersionGif89
      #EncoderValueRenderProgressive
      #EncoderValueRenderNonProgressive
      #EncoderValueTransformRotate90
      #EncoderValueTransformRotate180
      #EncoderValueTransformRotate270
      #EncoderValueTransformFlipHorizontal
      #EncoderValueTransformFlipVertical
      #EncoderValueMultiFrame
      #EncoderValueLastFrame
      #EncoderValueFlush
      #EncoderValueFrameDimensionTime
      #EncoderValueFrameDimensionResolution
      #EncoderValueFrameDimensionPage
    EndEnumeration ;}

  ;Pixel Format
  ;{
    #PixelFormatIndexed         = $00010000
    #PixelFormatGDI             = $00020000
    #PixelFormatAlpha           = $00040000
    #PixelFormatPAlpha          = $00080000
    #PixelFormatExtended        = $00100000
    #PixelFormatCanonical       = $00200000 
    #PixelFormatUndefined       = 0
    #PixelFormatDontCare        = 0
    #PixelFormat1bppIndexed     = (1 | ( 1 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
    #PixelFormat4bppIndexed     = (2 | ( 4 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
    #PixelFormat8bppIndexed     = (3 | ( 8 << 8) | #PixelFormatIndexed | #PixelFormatGDI)
    #PixelFormat16bppGrayScale  = (4 | (16 << 8) | #PixelFormatExtended)
    #PixelFormat16bppRGB555     = (5 | (16 << 8) | #PixelFormatGDI)
    #PixelFormat16bppRGB565     = (6 | (16 << 8) | #PixelFormatGDI)
    #PixelFormat16bppARGB1555   = (7 | (16 << 8) | #PixelFormatAlpha | #PixelFormatGDI)
    #PixelFormat24bppRGB        = (8 | (24 << 8) | #PixelFormatGDI)
    #PixelFormat32bppRGB        = (9 | (32 << 8) | #PixelFormatGDI)
    #PixelFormat32bppARGB       = (10 | (32 << 8) | #PixelFormatAlpha | #PixelFormatGDI | #PixelFormatCanonical)
    #PixelFormat32bppPARGB      = (11 | (32 << 8) | #PixelFormatAlpha | #PixelFormatPAlpha | #PixelFormatGDI)
    #PixelFormat48bppRGB        = (12 | (48 << 8) | #PixelFormatExtended)
    #PixelFormat64bppARGB       = (13 | (64 << 8) | #PixelFormatAlpha  | #PixelFormatCanonical | #PixelFormatExtended)
    #PixelFormat64bppPARGB      = (14 | (64 << 8) | #PixelFormatAlpha  | #PixelFormatPAlpha | #PixelFormatExtended)
    #PixelFormat32bppCMYK       = (15 | (32 << 8))
    #PixelFormatMax             = 16
  ;}

  ;Image flags.
  ;{
    #ImageFlagsNone                 = 0
    ;Low-word: shared with SINKFLAG_x
      #ImageFlagsScalable           = $0001
      #ImageFlagsHasAlpha           = $0002
      #ImageFlagsHasTranslucent     = $0004
      #ImageFlagsPartiallyScalable  = $0008
    ;Low-word: color space definition
      #ImageFlagsColorSpaceRGB      = $0010
      #ImageFlagsColorSpaceCMYK     = $0020
      #ImageFlagsColorSpaceGRAY     = $0040
      #ImageFlagsColorSpaceYCBCR    = $0080
      #ImageFlagsColorSpaceYCCK     = $0100
    ;Low-word: image size info
      #ImageFlagsHasRealDPI         = $1000
      #ImageFlagsHasRealPixelSize   = $2000
    ;High-word
      #ImageFlagsReadOnly           = $00010000
      #ImageFlagsCaching            = $00020000 ;} 

  ;Image lock mode.
  ;{
    #ImageLockModeRead          = 1 
    #ImageLockModeWrite         = 2
    #ImageLockModeUserInputBuf  = 4
  ;}

  ;Standard ARGB colors.
    Enumeration ;{
      #ARGB_AliceBlue            = $FFF0F8FF
      #ARGB_AntiqueWhite         = $FFFAEBD7
      #ARGB_Aqua                 = $FF00FFFF
      #ARGB_Aquamarine           = $FF7FFFD4
      #ARGB_Azure                = $FFF0FFFF
      #ARGB_Beige                = $FFF5F5DC
      #ARGB_Bisque               = $FFFFE4C4
      #ARGB_Black                = $FF000000
      #ARGB_BlanchedAlmond       = $FFFFEBCD
      #ARGB_Blue                 = $FF0000FF
      #ARGB_BlueViolet           = $FF8A2BE2
      #ARGB_Brown                = $FFA52A2A
      #ARGB_BurlyWood            = $FFDEB887
      #ARGB_CadetBlue            = $FF5F9EA0
      #ARGB_Chartreuse           = $FF7FFF00
      #ARGB_Chocolate            = $FFD2691E
      #ARGB_Coral                = $FFFF7F50
      #ARGB_CornflowerBlue       = $FF6495ED
      #ARGB_Cornsilk             = $FFFFF8DC
      #ARGB_Crimson              = $FFDC143C
      #ARGB_Cyan                 = $FF00FFFF
      #ARGB_DarkBlue             = $FF00008B
      #ARGB_DarkCyan             = $FF008B8B
      #ARGB_DarkGoldenrod        = $FFB8860B
      #ARGB_DarkGray             = $FFA9A9A9
      #ARGB_DarkGreen            = $FF006400
      #ARGB_DarkKhaki            = $FFBDB76B
      #ARGB_DarkMagenta          = $FF8B008B
      #ARGB_DarkOliveGreen       = $FF556B2F
      #ARGB_DarkOrange           = $FFFF8C00
      #ARGB_DarkOrchid           = $FF9932CC
      #ARGB_DarkRed              = $FF8B0000
      #ARGB_DarkSalmon           = $FFE9967A
      #ARGB_DarkSeaGreen         = $FF8FBC8F
      #ARGB_DarkSlateBlue        = $FF483D8B
      #ARGB_DarkSlateGray        = $FF2F4F4F
      #ARGB_DarkTurquoise        = $FF00CED1
      #ARGB_DarkViolet           = $FF9400D3
      #ARGB_DeepPink             = $FFFF1493
      #ARGB_DeepSkyBlue          = $FF00BFFF
      #ARGB_DimGray              = $FF696969
      #ARGB_DodgerBlue           = $FF1E90FF
      #ARGB_Firebrick            = $FFB22222
      #ARGB_FloralWhite          = $FFFFFAF0
      #ARGB_ForestGreen          = $FF228B22
      #ARGB_Fuchsia              = $FFFF00FF
      #ARGB_Gainsboro            = $FFDCDCDC
      #ARGB_GhostWhite           = $FFF8F8FF
      #ARGB_Gold                 = $FFFFD700
      #ARGB_Goldenrod            = $FFDAA520
      #ARGB_Gray                 = $FF808080
      #ARGB_Green                = $FF008000
      #ARGB_GreenYellow          = $FFADFF2F
      #ARGB_Honeydew             = $FFF0FFF0
      #ARGB_HotPink              = $FFFF69B4
      #ARGB_IndianRed            = $FFCD5C5C
      #ARGB_Indigo               = $FF4B0082
      #ARGB_Ivory                = $FFFFFFF0
      #ARGB_Khaki                = $FFF0E68C
      #ARGB_Lavender             = $FFE6E6FA
      #ARGB_LavenderBlush        = $FFFFF0F5
      #ARGB_LawnGreen            = $FF7CFC00
      #ARGB_LemonChiffon         = $FFFFFACD
      #ARGB_LightBlue            = $FFADD8E6
      #ARGB_LightCoral           = $FFF08080
      #ARGB_LightCyan            = $FFE0FFFF
      #ARGB_LightGoldenrodYellow = $FFFAFAD2
      #ARGB_LightGray            = $FFD3D3D3
      #ARGB_LightGreen           = $FF90EE90
      #ARGB_LightPink            = $FFFFB6C1
      #ARGB_LightSalmon          = $FFFFA07A
      #ARGB_LightSeaGreen        = $FF20B2AA
      #ARGB_LightSkyBlue         = $FF87CEFA
      #ARGB_LightSlateGray       = $FF778899
      #ARGB_LightSteelBlue       = $FFB0C4DE
      #ARGB_LightYellow          = $FFFFFFE0
      #ARGB_Lime                 = $FF00FF00
      #ARGB_LimeGreen            = $FF32CD32
      #ARGB_Linen                = $FFFAF0E6
      #ARGB_Magenta              = $FFFF00FF
      #ARGB_Maroon               = $FF800000
      #ARGB_MediumAquamarine     = $FF66CDAA
      #ARGB_MediumBlue           = $FF0000CD
      #ARGB_MediumOrchid         = $FFBA55D3
      #ARGB_MediumPurple         = $FF9370DB
      #ARGB_MediumSeaGreen       = $FF3CB371
      #ARGB_MediumSlateBlue      = $FF7B68EE
      #ARGB_MediumSpringGreen    = $FF00FA9A
      #ARGB_MediumTurquoise      = $FF48D1CC
      #ARGB_MediumVioletRed      = $FFC71585
      #ARGB_MidnightBlue         = $FF191970
      #ARGB_MintCream            = $FFF5FFFA
      #ARGB_MistyRose            = $FFFFE4E1
      #ARGB_Moccasin             = $FFFFE4B5
      #ARGB_NavajoWhite          = $FFFFDEAD
      #ARGB_Navy                 = $FF000080
      #ARGB_OldLace              = $FFFDF5E6
      #ARGB_Olive                = $FF808000
      #ARGB_OliveDrab            = $FF6B8E23
      #ARGB_Orange               = $FFFFA500
      #ARGB_OrangeRed            = $FFFF4500
      #ARGB_Orchid               = $FFDA70D6
      #ARGB_PaleGoldenrod        = $FFEEE8AA
      #ARGB_PaleGreen            = $FF98FB98
      #ARGB_PaleTurquoise        = $FFAFEEEE
      #ARGB_PaleVioletRed        = $FFDB7093
      #ARGB_PapayaWhip           = $FFFFEFD5
      #ARGB_PeachPuff            = $FFFFDAB9
      #ARGB_Peru                 = $FFCD853F
      #ARGB_Pink                 = $FFFFC0CB
      #ARGB_Plum                 = $FFDDA0DD
      #ARGB_PowderBlue           = $FFB0E0E6
      #ARGB_Purple               = $FF800080
      #ARGB_Red                  = $FFFF0000
      #ARGB_RosyBrown            = $FFBC8F8F
      #ARGB_RoyalBlue            = $FF4169E1
      #ARGB_SaddleBrown          = $FF8B4513
      #ARGB_Salmon               = $FFFA8072
      #ARGB_SandyBrown           = $FFF4A460
      #ARGB_SeaGreen             = $FF2E8B57
      #ARGB_SeaShell             = $FFFFF5EE
      #ARGB_Sienna               = $FFA0522D
      #ARGB_Silver               = $FFC0C0C0
      #ARGB_SkyBlue              = $FF87CEEB
      #ARGB_SlateBlue            = $FF6A5ACD
      #ARGB_SlateGray            = $FF708090
      #ARGB_Snow                 = $FFFFFAFA
      #ARGB_SpringGreen          = $FF00FF7F
      #ARGB_SteelBlue            = $FF4682B4
      #ARGB_Tan                  = $FFD2B48C
      #ARGB_Teal                 = $FF008080
      #ARGB_Thistle              = $FFD8BFD8
      #ARGB_Tomato               = $FFFF6347
      #ARGB_TRANSPARENT          = $00FFFFFF
      #ARGB_Turquoise            = $FF40E0D0
      #ARGB_Violet               = $FFEE82EE
      #ARGB_Wheat                = $FFF5DEB3
      #ARGB_White                = $FFFFFFFF
      #ARGB_WhiteSmoke           = $FFF5F5F5
      #ARGB_Yellow               = $FFFFFF00
      #ARGB_YellowGreen          = $FF9ACD32
    EndEnumeration ;}

  ;PaletteType
    Enumeration 0 ;{
      #PaletteTypeCustom
      #PaletteTypeOptimal
      #PaletteTypeFixedBW
      #PaletteTypeFixedHalftone8
      #PaletteTypeFixedHalftone27
      #PaletteTypeFixedHalftone64
      #PaletteTypeFixedHalftone125
      #PaletteTypeFixedHalftone216
      #PaletteTypeFixedHalftone252
      #PaletteTypeFixedHalftone256
    EndEnumeration ;} 

  ;PaletteFlags
    Enumeration ;{
      #PaletteFlagsHasAlpha   = $0001
      #PaletteFlagsGrayScale  = $0002
      #PaletteFlagsHalftone   = $0004
    EndEnumeration ;} 

  ;Image Property Types.
  ;{
    #PropertyTagTypeByte      = 1
    #PropertyTagTypeASCII     = 2
    #PropertyTagTypeShort     = 3
    #PropertyTagTypeLong      = 4
    #PropertyTagTypeRational  = 5
    #PropertyTagTypeUndefined = 7
    #PropertyTagTypeSLONG     = 9
    #PropertyTagTypeSRational = 10 ;}

  ;Image property ID Tags.
  ;{
    #PropertyTagExifIFD                         = $8769
    #PropertyTagGpsIFD                          = $8825
    #PropertyTagNewSubfileType                  = $00FE
    #PropertyTagSubfileType                     = $00FF
    #PropertyTagImageWidth                      = $0100
    #PropertyTagImageHeight                     = $0101
    #PropertyTagBitsPerSample                   = $0102
    #PropertyTagCompression                     = $0103
    #PropertyTagPhotometricInterp               = $0106
    #PropertyTagThreshHolding                   = $0107
    #PropertyTagCellWidth                       = $0108
    #PropertyTagCellHeight                      = $0109
    #PropertyTagFillOrder                       = $010A
    #PropertyTagDocumentName                    = $010D
    #PropertyTagImageDescription                = $010E
    #PropertyTagEquipMake                       = $010F
    #PropertyTagEquipModel                      = $0110
    #PropertyTagStripOffsets                    = $0111
    #PropertyTagOrientation                     = $0112
    #PropertyTagSamplesPerPixel                 = $0115
    #PropertyTagRowsPerStrip                    = $0116
    #PropertyTagStripBytesCount                 = $0117
    #PropertyTagMinSampleValue                  = $0118
    #PropertyTagMaxSampleValue                  = $0119
    #PropertyTagXResolution                     = $011A
    #PropertyTagYResolution                     = $011B
    #PropertyTagPlanarConfig                    = $011C
    #PropertyTagPageName                        = $011D
    #PropertyTagXPosition                       = $011E
    #PropertyTagYPosition                       = $011F
    #PropertyTagFreeOffset                      = $0120
    #PropertyTagFreeByteCounts                  = $0121
    #PropertyTagGrayResponseUnit                = $0122
    #PropertyTagGrayResponseCurve               = $0123
    #PropertyTagT4Option                        = $0124
    #PropertyTagT6Option                        = $0125
    #PropertyTagResolutionUnit                  = $0128
    #PropertyTagPageNumber                      = $0129
    #PropertyTagTransferFuncition               = $012D
    #PropertyTagSoftwareUsed                    = $0131
    #PropertyTagDateTime                        = $0132
    #PropertyTagArtist                          = $013B
    #PropertyTagHostComputer                    = $013C
    #PropertyTagPredictor                       = $013D
    #PropertyTagWhitePoint                      = $013E
    #PropertyTagPrimaryChromaticities           = $013F
    #PropertyTagColorMap                        = $0140
    #PropertyTagHalftoneHints                   = $0141
    #PropertyTagTileWidth                       = $0142
    #PropertyTagTileLength                      = $0143
    #PropertyTagTileOffset                      = $0144
    #PropertyTagTileByteCounts                  = $0145
    #PropertyTagInkSet                          = $014C
    #PropertyTagInkNames                        = $014D
    #PropertyTagNumberOfInks                    = $014E
    #PropertyTagDotRange                        = $0150
    #PropertyTagTargetPrinter                   = $0151
    #PropertyTagExtraSamples                    = $0152
    #PropertyTagSampleFormat                    = $0153
    #PropertyTagSMinSampleValue                 = $0154
    #PropertyTagSMaxSampleValue                 = $0155
    #PropertyTagTransferRange                   = $0156
    #PropertyTagJPEGProc                        = $0200
    #PropertyTagJPEGInterFormat                 = $0201
    #PropertyTagJPEGInterLength                 = $0202
    #PropertyTagJPEGRestartInterval             = $0203
    #PropertyTagJPEGLosslessPredictors          = $0205
    #PropertyTagJPEGPointTransforms             = $0206
    #PropertyTagJPEGQTables                     = $0207
    #PropertyTagJPEGDCTables                    = $0208
    #PropertyTagJPEGACTables                    = $0209
    #PropertyTagYCbCrCoefficients               = $0211
    #PropertyTagYCbCrSubsampling                = $0212
    #PropertyTagYCbCrPositioning                = $0213
    #PropertyTagREFBlackWhite                   = $0214
    #PropertyTagICCProfile                      = $8773
    #PropertyTagGamma                           = $0301
    #PropertyTagICCProfileDescriptor            = $0302
    #PropertyTagSRGBRenderingIntent             = $0303
    #PropertyTagImageTitle                      = $0320
    #PropertyTagCopyright                       = $8298
    ; Extra TAGs (Adobe Image Information tags etc.)
    #PropertyTagResolutionXUnit                 = $5001
    #PropertyTagResolutionYUnit                 = $5002
    #PropertyTagResolutionXLengthUnit           = $5003
    #PropertyTagResolutionYLengthUnit           = $5004
    #PropertyTagPrintFlags                      = $5005
    #PropertyTagPrintFlagsVersion               = $5006
    #PropertyTagPrintFlagsCrop                  = $5007
    #PropertyTagPrintFlagsBleedWidth            = $5008
    #PropertyTagPrintFlagsBleedWidthScale       = $5009
    #PropertyTagHalftoneLPI                     = $500A
    #PropertyTagHalftoneLPIUnit                 = $500B
    #PropertyTagHalftoneDegree                  = $500C
    #PropertyTagHalftoneShape                   = $500D
    #PropertyTagHalftoneMisc                    = $500E
    #PropertyTagHalftoneScreen                  = $500F
    #PropertyTagJPEGQuality                     = $5010
    #PropertyTagGridSize                        = $5011
    #PropertyTagThumbnailFormat                 = $5012
    #PropertyTagThumbnailWidth                  = $5013
    #PropertyTagThumbnailHeight                 = $5014
    #PropertyTagThumbnailColorDepth             = $5015
    #PropertyTagThumbnailPlanes                 = $5016
    #PropertyTagThumbnailRawBytes               = $5017
    #PropertyTagThumbnailSize                   = $5018
    #PropertyTagThumbnailCompressedSize         = $5019
    #PropertyTagColorTransferFunction           = $501A
    #PropertyTagThumbnailData                   = $501B
    ; Thumbnail related TAGs
    #PropertyTagThumbnailImageWidth             = $5020
    #PropertyTagThumbnailImageHeight            = $5021
    #PropertyTagThumbnailBitsPerSample          = $5022
    #PropertyTagThumbnailCompression            = $5023
    #PropertyTagThumbnailPhotometricInterp      = $5024
    #PropertyTagThumbnailImageDescription       = $5025
    #PropertyTagThumbnailEquipMake              = $5026
    #PropertyTagThumbnailEquipModel             = $5027
    #PropertyTagThumbnailStripOffsets           = $5028
    #PropertyTagThumbnailOrientation            = $5029
    #PropertyTagThumbnailSamplesPerPixel        = $502A
    #PropertyTagThumbnailRowsPerStrip           = $502B
    #PropertyTagThumbnailStripBytesCount        = $502C
    #PropertyTagThumbnailResolutionX            = $502D
    #PropertyTagThumbnailResolutionY            = $502E
    #PropertyTagThumbnailPlanarConfig           = $502F
    #PropertyTagThumbnailResolutionUnit         = $5030
    #PropertyTagThumbnailTransferFunction       = $5031
    #PropertyTagThumbnailSoftwareUsed           = $5032
    #PropertyTagThumbnailDateTime               = $5033
    #PropertyTagThumbnailArtist                 = $5034
    #PropertyTagThumbnailWhitePoint             = $5035
    #PropertyTagThumbnailPrimaryChromaticities  = $5036 
    #PropertyTagThumbnailYCbCrCoefficients      = $5037
    #PropertyTagThumbnailYCbCrSubsampling       = $5038
    #PropertyTagThumbnailYCbCrPositioning       = $5039
    #PropertyTagThumbnailRefBlackWhite          = $503A
    #PropertyTagThumbnailCopyRight              = $503B
    #PropertyTagLuminanceTable                  = $5090
    #PropertyTagChrominanceTable                = $5091
    #PropertyTagFrameDelay                      = $5100
    #PropertyTagLoopCount                       = $5101
    #PropertyTagGlobalPalette                   = $5102
    #PropertyTagIndexBackground                 = $5103
    #PropertyTagIndexTransparent                = $5104
    #PropertyTagPixelUnit                       = $5110
    #PropertyTagPixelPerUnitX                   = $5111
    #PropertyTagPixelPerUnitY                   = $5112
    #PropertyTagPaletteHistogram                = $5113
    ;EXIF specific tags
    #PropertyTagExifExposureTime                = $829A
    #PropertyTagExifFNumber                     = $829D
    #PropertyTagExifExposureProg                = $8822
    #PropertyTagExifSpectralSense               = $8824
    #PropertyTagExifISOSpeed                    = $8827
    #PropertyTagExifOECF                        = $8828
    #PropertyTagExifVer                         = $9000
    #PropertyTagExifDTOrig                      = $9003
    #PropertyTagExifDTDigitized                 = $9004
    #PropertyTagExifCompConfig                  = $9101
    #PropertyTagExifCompBPP                     = $9102
    #PropertyTagExifShutterSpeed                = $9201
    #PropertyTagExifAperture                    = $9202
    #PropertyTagExifBrightness                  = $9203
    #PropertyTagExifExposureBias                = $9204
    #PropertyTagExifMaxAperture                 = $9205
    #PropertyTagExifSubjectDist                 = $9206
    #PropertyTagExifMeteringMode                = $9207
    #PropertyTagExifLightSource                 = $9208
    #PropertyTagExifFlash                       = $9209
    #PropertyTagExifFocalLength                 = $920A
    #PropertyTagExifSubjectArea                 = $9214
    #PropertyTagExifMakerNote                   = $927C
    #PropertyTagExifUserComment                 = $9286
    #PropertyTagExifDTSubsec                    = $9290
    #PropertyTagExifDTOrigSS                    = $9291
    #PropertyTagExifDTDigSS                     = $9292
    #PropertyTagExifFPXVer                      = $A000
    #PropertyTagExifColorSpace                  = $A001
    #PropertyTagExifPixXDim                     = $A002
    #PropertyTagExifPixYDim                     = $A003
    #PropertyTagExifRelatedWav                  = $A004
    #PropertyTagExifInterop                     = $A005
    #PropertyTagExifFlashEnergy                 = $A20B
    #PropertyTagExifSpatialFR                   = $A20C
    #PropertyTagExifFocalXRes                   = $A20E
    #PropertyTagExifFocalYRes                   = $A20F
    #PropertyTagExifFocalResUnit                = $A210
    #PropertyTagExifSubjectLoc                  = $A214
    #PropertyTagExifExposureIndex               = $A215
    #PropertyTagExifSensingMethod               = $A217
    #PropertyTagExifFileSource                  = $A300
    #PropertyTagExifSceneType                   = $A301
    #PropertyTagExifCfaPattern                  = $A302
    ;New EXIF 2.2 properties
    #PropertyTagExifCustomRendered              = $A401
    #PropertyTagExifExposureMode                = $A402
    #PropertyTagExifWhiteBalance                = $A403
    #PropertyTagExifDigitalZoomRatio            = $A404
    #PropertyTagExifFocalLengthIn35mmFilm       = $A405
    #PropertyTagExifSceneCaptureType            = $A406
    #PropertyTagExifGainControl                 = $A407
    #PropertyTagExifContrast                    = $A408
    #PropertyTagExifSaturation                  = $A409
    #PropertyTagExifSharpness                   = $A40A
    #PropertyTagExifDeviceSettingDesc           = $A40B
    #PropertyTagExifSubjectDistanceRange        = $A40C
    #PropertyTagExifUniqueImageID               = $A420
    #PropertyTagGpsVer                          = $0000
    #PropertyTagGpsLatitudeRef                  = $0001
    #PropertyTagGpsLatitude                     = $0002
    #PropertyTagGpsLongitudeRef                 = $0003
    #PropertyTagGpsLongitude                    = $0004
    #PropertyTagGpsAltitudeRef                  = $0005
    #PropertyTagGpsAltitude                     = $0006
    #PropertyTagGpsGpsTime                      = $0007
    #PropertyTagGpsGpsSatellites                = $0008
    #PropertyTagGpsGpsStatus                    = $0009
    #PropertyTagGpsGpsMeasureMode               = $00A
    #PropertyTagGpsGpsDop                       = $000B
    #PropertyTagGpsSpeedRef                     = $000C
    #PropertyTagGpsSpeed                        = $000D
    #PropertyTagGpsTrackRef                     = $000E
    #PropertyTagGpsTrack                        = $000F
    #PropertyTagGpsImgDirRef                    = $0010
    #PropertyTagGpsImgDir                       = $0011
    #PropertyTagGpsMapDatum                     = $0012
    #PropertyTagGpsDestLatRef                   = $0013
    #PropertyTagGpsDestLat                      = $0014
    #PropertyTagGpsDestLongRef                  = $0015
    #PropertyTagGpsDestLong                     = $0016
    #PropertyTagGpsDestBearRef                  = $0017
    #PropertyTagGpsDestBear                     = $0018
    #PropertyTagGpsDestDistRef                  = $0019
    #PropertyTagGpsDestDist                     = $001A
    #PropertyTagGpsProcessingMethod             = $001B
    #PropertyTagGpsAreaInformation              = $001C
    #PropertyTagGpsDate                         = $001D
    #PropertyTagGpsDifferential                 = $001E ;}

  ;RotateFlipTypes.
    Enumeration ;{
      #RotateNoneFlipNone
      #Rotate90FlipNone
      #Rotate180FlipNone
      #Rotate270FlipNone
      #RotateNoneFlipX
      #Rotate90FlipX
      #Rotate180FlipX
      #Rotate270FlipX
      #RotateNoneFlipY   = #Rotate180FlipX
      #Rotate90FlipY     = #Rotate270FlipX
      #Rotate180FlipY    = #RotateNoneFlipX
      #Rotate270FlipY    = #Rotate90FlipX
      #RotateNoneFlipXY  = #Rotate180FlipNone
      #Rotate90FlipXY    = #Rotate270FlipNone
      #Rotate180FlipXY   = #RotateNoneFlipNone
      #Rotate270FlipXY   = #Rotate90FlipNone
    EndEnumeration ;} 

  ;Unit.
    Enumeration ;{
      #UnitWorld
      #UnitDisplay
      #UnitPixel
      #UnitPoint 
      #UnitInch 
      #UnitDocument
      #UnitMillimeter 
    EndEnumeration ;} 

  ;FontStyle
    Enumeration 0 ;{
      #FontStyleRegular
      #FontStyleBold
      #FontStyleItalic
      #FontStyleBoldItalic
      #FontStyleUnderline
      #FontStyleStrikeout = 8
    EndEnumeration ;} 

  ;BrushType
    Enumeration 0 ;{
      #BrushTypeSolidColor
      #BrushTypeHatchFill
      #BrushTypeTextureFill
      #BrushTypePathGradient
      #BrushTypeLinearGradient
    EndEnumeration ;} 

  ;HatchStyle
    Enumeration ;{
      #HatchStyleHorizontal             = 0
      #HatchStyleVertical               = 1
      #HatchStyleForwardDiagonal        = 2
      #HatchStyleBackwardDiagonal       = 3
      #HatchStyleCross                  = 4
      #HatchStyleDiagonalCross          = 5
      #HatchStyle05Percent              = 6
      #HatchStyle10Percent              = 7
      #HatchStyle20Percent              = 8
      #HatchStyle25Percent              = 9
      #HatchStyle30Percent              = 10
      #HatchStyle40Percent              = 11
      #HatchStyle50Percent              = 12
      #HatchStyle60Percent              = 13
      #HatchStyle70Percent              = 14
      #HatchStyle75Percent              = 15
      #HatchStyle80Percent              = 16
      #HatchStyle90Percent              = 17
      #HatchStyleLightDownwardDiagonal  = 18
      #HatchStyleLightUpwardDiagonal    = 19
      #HatchStyleDarkDownwardDiagonal   = 20
      #HatchStyleDarkUpwardDiagonal     = 21
      #HatchStyleWideDownwardDiagonal   = 22
      #HatchStyleWideUpwardDiagonal     = 23
      #HatchStyleLightVertical          = 24
      #HatchStyleLightHorizontal        = 25
      #HatchStyleNarrowVertical         = 26
      #HatchStyleNarrowHorizontal       = 27
      #HatchStyleDarkVertical           = 28
      #HatchStyleDarkHorizontal         = 29
      #HatchStyleDashedDownwardDiagonal = 30
      #HatchStyleDashedUpwardDiagonal   = 31
      #HatchStyleDashedHorizontal       = 32
      #HatchStyleDashedVertical         = 33
      #HatchStyleSmallConfetti          = 34
      #HatchStyleLargeConfetti          = 35
      #HatchStyleZigZag                 = 36
      #HatchStyleWave                   = 37
      #HatchStyleDiagonalBrick          = 38
      #HatchStyleHorizontalBrick        = 39
      #HatchStyleWeave                  = 40
      #HatchStylePlaid                  = 41
      #HatchStyleDivot                  = 42
      #HatchStyleDottedGrid             = 43
      #HatchStyleDottedDiamond          = 44
      #HatchStyleShingle                = 45
      #HatchStyleTrellis                = 46
      #HatchStyleSphere                 = 47
      #HatchStyleSmallGrid              = 48
      #HatchStyleSmallCheckerBoard      = 49
      #HatchStyleLargeCheckerBoard      = 50
      #HatchStyleOutlinedDiamond        = 51
      #HatchStyleSolidDiamond           = 52
      #HatchStyleTotal
      #HatchStyleLargeGrid              = #HatchStyleCross
      #HatchStyleMin                    = #HatchStyleHorizontal
      #HatchStyleMax                    = #HatchStyleTotal - 1
    EndEnumeration ;} 

  ;WrapMode For brushes
    Enumeration ;{
      #WrapModeTile       = 0
      #WrapModeTileFlipX  = 1
      #WrapModeTileFlipY  = 2
      #WrapModeTileFlipXY = 3
      #WrapModeClamp      = 4
    EndEnumeration ;}

  ;LinearGradientMode
    Enumeration 0 ;{
      #LinearGradientModeHorizontal
      #LinearGradientModeVertical
      #LinearGradientModeForwardDiagonal
      #LinearGradientModeBackwardDiagonal
    EndEnumeration ;} 

  ;MatrixOrder
    Enumeration 0 ;{
      #MatrixOrderPrepend
      #MatrixOrderAppend
    EndEnumeration ;} 
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-STRUCTURES.

  Structure GdiplusStartupInput ;{
    GdiPlusVersion.i
    *DebugEventCallback.DebugEventProc
    SuppressBackgroundThread.i 
    SuppressExternalCodecs.i 
  EndStructure ;}
  
  Structure GdiplusStartupOutput ;{
    *NotificationHook.NotificationHookProc
    *NotificationUnhook.NotificationUnhookProc
  EndStructure ;}

  ;The following is identical to an RGBQUAD structure.
    Structure ARGB ;{
      blue.a
      green.a
      red.a
      alpha.a
    EndStructure ;}

  ;The following two structures are used for setting encoder parameters.
    Structure EncoderParameter ;{
      guid.GUID
      NumberOfValues.l
      Type.l
      Value.i
    EndStructure ;}

    Structure EncoderParameters ;{
      Count.i
      Parameter.EncoderParameter[13]  ;Preallocate enough memory for the maximum number of parameters.
    EndStructure ;}

  ;Used with the BitmapData helper class.
    Structure BitmapData ;{ 
      nWidth.l
      nHeight.l
      Stride.l
      PixelFormat.l
      *Scan0.i
      Reserved.i
    EndStructure ;}

  Structure ColorPalette ;{
    Flags.l
    Count.l
    Entries.l[0]
  EndStructure ;}

  ;Used with the PropertyItem helper class.
    Structure PropertyItem ;{
      id.l
      length.l
      type.w
      padding1.w
      CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
        padding2.l
      CompilerEndIf
      value.i
    EndStructure ;} 

  ;Used with the RectF helper class.
    Structure RectF ;{
      x.f
      y.f
      width.f
      height.f
    EndStructure ;} 

  ;Used with the RectI helper class.
    Structure RectI ;{
      x.l
      y.l
      width.l
      height.l
    EndStructure ;} 

  ;Used with the PointF helper class.
    Structure PointF ;{
      x.f 
      y.f 
    EndStructure ;} 

  ;Used with the PointI helper class.
    Structure PointI ;{
      x.l 
      y.l 
    EndStructure ;} 
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-IMPORTS.
  ;{
  CompilerSelect #PB_Compiler_Processor
    CompilerCase #PB_Processor_x86
      Import #PB_Compiler_FilePath + "GdiPlusx86.lib"
    CompilerCase #PB_Processor_x64
      Import #PB_Compiler_FilePath + "GdiPlusx64.lib"
  CompilerEndSelect
    ;Initialisation.
      GdiplusStartup(*token.INTEGER, *input.GdiplusStartupInput, *output.GdiplusStartupOutput=0) 
      GdiplusShutdown(token)
    ;Images.
      GdipBitmapGetPixel(*image, x, y, *color.INTEGER)
      GdipBitmapLockBits(*bitmap, *rect.RECT, flags, format, *lockedBitmapData.BitmapData)
      GdipBitmapSetPixel(*image, x, y, color)
      GdipBitmapSetResolution(*image, xdpi.f, ydpi.f)
      GdipBitmapUnlockBits(*bitmap, *lockedBitmapData.BitmapData) 
      GdipCloneBitmapArea(x.f, y.f, width.f, height.f, format, *srcBitmap, *image.INTEGER)
      GdipCloneBitmapAreaI(x, y, width, height, format, *srcBitmap, *image.INTEGER)
      GdipCloneBrush(*brush, *cloneBrush.INTEGER)
      GdipCloneFont(*font, *cloneFont.INTEGER)
      GdipCloneFontFamily(*FontFamily, *clonedFontFamily.INTEGER)
      GdipCloneImage(*image, *cloneImage.INTEGER)
      GdipCloneMatrix(*matrix, *cloneMatrix.INTEGER)
      GdipCreateBitmapFromGdiDib(*bitmapinfo.BITMAPINFO, *pxBits, *image.INTEGER)
      GdipCreateBitmapFromGraphics(width, height, *graphics, *image.INTEGER)
      GdipCreateBitmapFromHBITMAP(hbm, hpal, *image.INTEGER)
      GdipCreateBitmapFromHICON(hicon, *image.INTEGER)
      GdipCreateBitmapFromResource(hInstance, lpBitmapName.p-unicode, *image.INTEGER)
      GdipCreateBitmapFromScan0(width, height, stride, format, *scan0, *image.INTEGER)
      GdipCreateFont(*fontFamily, emSize.f, fontStyle, unit, *font.INTEGER)
      GdipCreateFontFamilyFromName(name.p-unicode, *fontCollection, *FontFamily.INTEGER)
      GdipCreateFontFromDC(hdc, *font.INTEGER)
      GdipCreateFontFromLogfontA(hdc, *logfont.LOGFONT, *font.INTEGER)
      GdipCreateFontFromLogfontW(hdc, *logfont.LOGFONT, *font.INTEGER)
      GdipCreateHatchBrush(hatchstyle, foreColor, backColor, *brush.INTEGER)
      GdipCreateHBITMAPFromBitmap(*image, *bmp.INTEGER, backColor)
      GdipCreateHICONFromBitmap(*image, *icon.INTEGER)
      GdipCreateLineBrush(*point1.PointF, *point2.PointF, color1, color2, wrapMode, *lineGradient.INTEGER)
      GdipCreateLineBrushI(*point1.Point, *point2.Point, color1, color2, wrapMode, *lineGradient.INTEGER)
      GdipCreateLineBrushFromRect(*rect.RectF, color1, color2, mode, wrapMode, *lineGradient.INTEGER)
      GdipCreateLineBrushFromRectI(*rect.RectI, color1, color2, mode, wrapMode, *lineGradient.INTEGER)
      GdipCreateMatrix(*matrix.INTEGER)
      GdipCreateMatrix2(m11.f, m12.f, m21.f, m22.f, dx.f, dy.f, *matrix.INTEGER)
      GdipCreateMatrix3(*rect.RectF, *dstplg.PointF, *matrix.INTEGER)
      GdipCreateMatrix3I(*rect.RectI, *dstplg.PointI, *matrix.INTEGER)
      GdipDeleteBrush(*brush)
      GdipDeleteFont(*font)
      GdipDeleteFontFamily(*FontFamily)
      GdipDeleteMatrix(*matrix)
      GdipDeletePrivateFontCollection(*fontCollection)
      GdipDisposeImage(*image)
      GdipGetBrushType(*brush, *type.INTEGER)
      GdipGetCellAscent(*fontFamily, fontStyle, *CellAscent.WORD)
      GdipGetCellDescent(*fontFamily, fontStyle, *CellDescent.WORD)
      GdipGetEmHeight(*fontFamily, fontStyle, *EmHeight.WORD)
      GdipGetFamily(*font, *family.INTEGER)
      GdipGetFamilyName(*fontFamily, *buffer, language)
      GdipGetFontCollectionFamilyCount(*fontCollection, *numFound.INTEGER)
      GdipGetFontCollectionFamilyList( *fontCollection, numSought, *buffer, *numFound.INTEGER)
      GdipGetFontHeight(*font, *graphics, *height.FLOAT)
      GdipGetFontHeightGivenDPI(*font, dpi.f, *height.FLOAT)
      GdipGetFontSize(*font, *size.FLOAT)
      GdipGetFontStyle(*font, *fontStyle.INTEGER)
      GdipGetFontUnit(*font, *unit.INTEGER)
      GdipGetGenericFontFamilyMonospace(*nativeFamily.INTEGER)
      GdipGetGenericFontFamilySansSerif(*nativeFamily.INTEGER)
      GdipGetGenericFontFamilySerif(*nativeFamily.INTEGER)
      GdipGetHatchBackgroundColor(*brush, *backColor.INTEGER)
      GdipGetHatchForegroundColor(*brush, *foreColor.INTEGER)
      GdipGetHatchStyle(*brush, *hatchstyle.INTEGER)
      GdipGetImageBounds(*image, *srcRect.RectF, *srcUnit.INTEGER)
      GdipGetImageFlags(*image, *flags.INTEGER)
      GdipGetImageHeight(*image, *height.INTEGER)
      GdipGetImageHorizontalResolution(*image, *resolution.FLOAT)
      GdipGetImagePalette(*image, *palette.ColorPalette, size)
      GdipGetImagePaletteSize(*image, *size.INTEGER)
      GdipGetImagePixelFormat(*image, *pixelFormat.INTEGER)
      GdipGetImageRawFormat(*image, *format.GUID)
      GdipGetLineBlend(*brush, *blend, *positions, count)
      GdipGetLineBlendCount(*brush, *count.INTEGER)
      GdipGetLineGammaCorrection(*brush, *useGammaCorrection.INTEGER)
      GdipGetLinePresetBlend(*brush, *blendColors, *positions, count)
      GdipGetLinePresetBlendCount(*brush, *count.INTEGER)
      GdipGetLineRect(*brush, *rect.RectF)
      GdipGetLineRectI(*brush, *rect.RectI)
      GdipGetLineSpacing(*fontFamily, fontStyle, *LineSpacing.WORD)
      GdipGetLineTransform(*brush, *matrix)
      GdipGetImageVerticalResolution(*image, *resolution.FLOAT)
      GdipGetImageWidth(*image, *width.INTEGER)
      GdipGetLineColors(*brush, *colors)
      GdipGetLineWrapMode(*brush, *wrapmode.INTEGER)
      GdipGetLogFontA(*font, *graphics, *logfont.LOGFONT)
      GdipGetLogFontW(*font, *graphics, *logfont.LOGFONT)
      GdipGetMatrixElements(*matrix, *matrixOut)
      GdipGetPropertyCount(*image, *numOfProperty.INTEGER)
      GdipGetPropertyIdList(*image, numOfProperty, *buffer)
      GdipGetPropertyItem(*image, propId, propSize, *PropertyItem)
      GdipGetPropertyItemSize(*image, propId, *size.INTEGER)
      GdipImageGetFrameCount(*image, *dimensionID.GUID, *count)
      GdipImageRotateFlip(*image, rfType)
      GdipImageSelectActiveFrame(*image, *dimensionID.GUID, frameIndex)
      GdipInvertMatrix(*matrix)
      GdipIsMatrixEqual(*matrix, *matrix2, *result.INTEGER)
      GdipIsMatrixIdentity(*matrix, *result.INTEGER)
      GdipIsMatrixInvertible(*matrix, *result.INTEGER)
      GdipIsStyleAvailable(*fontFamily, fontStyle, *IsStyleAvailable.INTEGER)
      GdipLoadImageFromFile(filename.p-unicode, *image.INTEGER)
      GdipLoadImageFromStream(stream.iStream, *image.INTEGER)
      GdipMultiplyLineTransform(*brush, *matrix, order)
      GdipMultiplyMatrix(*matrix, *matrix2, matrixOrder)
      GdipNewInstalledFontCollection(*fontCollection.INTEGER)
      GdipNewPrivateFontCollection(*fontCollection.INTEGER)
      GdipPrivateAddFontFile(*fontCollection, filename.p-unicode)
      GdipPrivateAddMemoryFont(*fontCollection, *memory, length)
      GdipRemovePropertyItem(*image, propId)
      GdipResetLineTransform(*brush)
      GdipRotateLineTransform(*brush, angle.f, matrixOrder)
      GdipRotateMatrix(*matrix, angle.f, matrixOrder)
      GdipSaveAdd(*image, *encoderParams.EncoderParameters=0)
      GdipSaveAddImage(*image, *newImage, *encoderParams.EncoderParameters=0)
      GdipSaveImageToFile(*image, filename.p-unicode, *clsidEncoder.CLSID, *encoderParams.EncoderParameters=0)
      GdipSaveImageToStream(*image, stream.iStream, *clsidEncoder.CLSID, *encoderParams.EncoderParameters=0)
      GdipScaleLineTransform(*brush, sx.f, sy.f, matrixOrder)
      GdipScaleMatrix(*matrix, scaleX.f, scaleY.f, matrixOrder)
      GdipSetImagePalette(*image, *palette.ColorPalette)
      GdipSetLineBlend(*brush, *blend, *positions, count)
      GdipSetLineColors(*brush, color1, color2)
      GdipSetLineGammaCorrection(*brush, useGammaCorrection)
      GdipSetLineLinearBlend(*brush, focus.f, scale.f)
      GdipSetLinePresetBlend(*brush, *blendColors, *positions, count)
      GdipSetLineTransform(*brush, *matrix)
      GdipSetLineWrapMode(*brush, wrapmode)
      GdipSetLineSigmaBlend(*brush, focus.f, scale.f)
      GdipSetMatrixElements(*matrix, m11.f, m12.f, m21.f, m22.f, dx.f, dy.f)
      GdipSetPropertyItem(*image, *item.PropertyItem)
      GdipShearMatrix(*matrix, shearX.f, shearY.f, matrixOrder)
      GdipTransformMatrixPoints(*matrix, *pts, count)
      GdipTransformMatrixPointsI(*matrix, *pts, count)
      GdipTranslateMatrix(*matrix, offsetX.f, offsetY.f, matrixOrder)
      GdipVectorTransformMatrixPoints(*matrix, *pts, count)
      GdipVectorTransformMatrixPointsI(*matrix, *pts, count)
GdipTranslateLineTransform(*brush, dx.f, dy.f, matrixOrder)
  EndImport ;}
;/////////////////////////////////////////////////////////////////////////////////


;/////////////////////////////////////////////////////////////////////////////////
;-GUIDs.

  DataSection
    ;Encoder CLSIDs.
      GUID_ImageEncoderBMP:
        Data.l $557cf400
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderJPEG:
        Data.l $557cf401
        Data.w $1a04, $11d3 
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderGIF:
        Data.l $557cf402
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderEMF:
        Data.l $557cf403
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderWMF:
        Data.l $557cf404
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderTIFF:
        Data.l $557cf405
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e
      GUID_ImageEncoderPNG:
        Data.l $557cf406
        Data.w $1a04, $11d3
        Data.b $9a, $73, $00, $00, $f8, $1e, $f3, $2e

    ;Encoder parameters.
      GUID_EncoderCompression:
        Data.l $E09D739D
        Data.w $CCD4, $44EE
        Data.b $8E, $BA, $3F, $BF, $8B, $E4, $FC, $58
      GUID_EncoderColorDepth:
        Data.l $66087055
        Data.w $AD66, $4C7C
        Data.b $9A, $18, $38, $A2, $31, $0B, $83, $37
      GUID_EncoderScanMethod:
        Data.l $3A4E2661
        Data.w $3109, $4E56
        Data.b $85, $36, $42, $C1, $56, $E7, $DC, $FA
      GUID_EncoderVersion:
        Data.l $24D18C76
        Data.w $814A, $41A4
        Data.b $BF, $53, $1C, $21, $9C, $CC, $F7, $97
      GUID_EncoderRenderMethod:
        Data.l $6D42C53A
        Data.w $229A, $4825
        Data.b $8B, $B7, $5C, $99, $E2, $B9, $A8, $B8
      GUID_EncoderQuality:
        Data.l $1D5BE4B5
        Data.w $FA4A, $452D
        Data.b $9C, $DD, $5D, $B3, $51, $05, $E7, $EB
      GUID_EncoderTransformation:
        Data.l $8D0EB2D1
        Data.w $A58E, $4EA8
        Data.b $AA, $14, $10, $80, $74, $B7, $B6, $F9
      GUID_EncoderLuminanceTable:
        Data.l $EDB33BCE
        Data.w $0266, $4A77
        Data.b $B9, $04, $27, $21, $60, $99, $E7, $17
      GUID_EncoderChrominanceTable:
        Data.l $F2E455DC
        Data.w $09B3, $4316
        Data.b $82, $60, $67, $6A, $DA, $32, $48, $1C
      GUID_EncoderSaveFlag:
        Data.l $292266FC
        Data.w $AC40, $47BF
        Data.b $8C, $FC, $A8, $5B, $89, $A6, $55, $DE
      GUID_EncoderColorSpace:
        Data.l $AE7A62A0
        Data.w $EE2C,$49D8
        Data.b $9D,$7,$1B,$A8,$A9,$27,$59,$6E
      GUID_EncoderImageItems:
        Data.l $63875E13
        Data.w $1F1D,$45AB
        Data.b $91, $95, $A2, $9B, $60, $66, $A6, $50
      GUID_EncoderSaveAsCMYK:
        Data.l $A219BBC9
        Data.w $A9D, $4005
        Data.b $A3, $EE, $3A, $42, $1B, $8B, $B0, $6C

    ;Multi-frame dimension IDs.
      GUID_FrameDimensionTime:
        Data.l $6aedbd6d
        Data.w $3fb5, $418a
        Data.b $83, $a6, $7f, $45, $22, $9d, $c8, $72
      GUID_FrameDimensionResolution:
        Data.l $84236f7b
        Data.w $3bd3, $428f
        Data.b $8d, $ab, $4e, $a1, $43, $9c, $a3, $15
      GUID_FrameDimensionPage:
        Data.l $7462dc86
        Data.w $6180, $4c7e
        Data.b $8e, $3f, $ee, $73, $33, $a7, $a4, $83

    ;Image formats.
      GUID_ImageFormatUndefined:
        Data.l $B96B3CA9
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatMemoryBMP:
        Data.l $B96B3CAA
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatBMP:
        Data.l $B96B3CAB
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatEMF:
        Data.l $B96B3CAC
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatWMF:
        Data.l $B96B3CAD
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatJPEG:
        Data.l $B96B3CAE
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatPNG:
        Data.l $B96B3CAF
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatGIF:
        Data.l $B96B3CB0
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatTIFF:
        Data.l $B96B3CB1
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatEXIF:
        Data.l $B96B3CB2
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatPhotoCD:
        Data.l $B96B3CB3
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatFlashPIX:
        Data.l $B96B3CB2
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
      GUID_ImageFormatIcon:
        Data.l $B96B3CB5
        Data.w $0728, $11D3
        Data.b $9D, $7B, $00, $00, $F8, $1E, $F3, $2E
  EndDataSection
;/////////////////////////////////////////////////////////////////////////////////

; IDE Options = PureBasic 4.51 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 1073
; FirstLine = 225
; Folding = AAgAA9
; EnableUnicode
; EnableXP
; Executable = nxReportU.dll